/*
 * OrdersHandler.java
 *
 * Created on 10 de agosto de 2004, 17:54
 */

package com.fenalco.servlets.shopkeeper;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.Order;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.database.Transaction;
import com.fenalco.utilities.lists.OrderViewShopKeeper;

/**
 * Este servlet administra las operaciones ver detalle y modificar que se
 * realicen sobre las ordenes de compra del minorista. Recibe el parámetro
 * <CODE>operationType</CODE> de mispedidos.jsp que indica el tipo de
 * operación a realizar , el parámetro <CODE>orderId</CODE> que indica el id
 * de la orden de compra sobre la cual se va a realizar la operación , y <CODE>
 * newStatus</CODE> que representa el indicador del nuevo estado en el caso de
 * ser modificado.
 * 
 * @author Mario Linares Vásquez
 */
public class OrdersHandler extends HttpServlet
{

	/**
	 * Inicializa the servlet.
	 * 
	 * @param config
	 * @throws ServletException
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destructor de el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Este método procesa las solicitudes de los métodos HTTP <code>GET</code>
	 * y <code>POST</code>. Realiza operaciones de acuerdo con la selección
	 * realizada por el minorista: -<CODE>operationType</CODE>= view Crea
	 * una instancia de <CODE>Order</CODE> con el parámetro <CODE>storeId
	 * </CODE> y luego la vista que se agrega al <CODE>request</CODE> como
	 * atributo con nombre <CODE>view</CODE> y luego se redirecciona el flujo
	 * a detallepedido.jsp
	 *  -<CODE>operationType</CODE>= update invoca la función miembro <CODE>
	 * changeState</CODE> con los parámetros <CODE>orderId</CODE> y <CODE>
	 * newStatus</CODE> y redirecciona el flujo al servlet /mispedidos
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{

		String url = "/minorista/mispedidos";
		String message = "";
		String operation = request.getParameter("operationType");
        HttpSession session = request.getSession( false );


	    try
	    {
	        if( session != null && ( User )session.getAttribute( "user" ) != null && ( ( User )session.getAttribute( "user" ) ).getRoleId() == 3 )
	        {
				if( operation.equals("view") )
				{
		
					int orderId = Integer.parseInt(request.getParameter("storeId"));
					Order order = new Order(orderId);
					OrderViewShopKeeper view = new OrderViewShopKeeper(order);
					request.setAttribute("view", view);
					url = "/minorista/detallepedido.jsp";
		
				}
				else if( operation.equals("update") )
				{
					String suffix = request.getParameter("combo");
					System.out.println(request.getParameter("status" + suffix));
					int newStatus = Integer.parseInt(request.getParameter("status"
							+ suffix));
					if( this.changeStatus(Integer.parseInt(suffix), newStatus) == false )
					{
						message = MessageBuilder.buildMessage(7);
					}
                                        
                                       // request.setAttribute("startDate", request.getParameter("startDate2") );
                                        //request.setAttribute("endDate", request.getParameter("endDate2") );
					url = "/minorista/mispedidos?startDate="+request.getParameter("startDate2")+"&endDate="+request.getParameter("endDate2")+"&order="+request.getParameter("order2");
				}
	        }
	        else
	        {
				message = MessageBuilder.buildMessage(15);
				url = "/index.jsp";
	        }
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }


		request.setAttribute("message", message);
		RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);

	}

	/**
	 * Procesa el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Procesa el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una breve descripción de el servlet.
	 * 
	 * @return
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

	/**
	 * Este método cambia el estado de la orden de compra seleccionada. Para tal
	 * efecto crea una instancia de <CODE>Order</CODE> con el parámetro <CODE>
	 * orderId</CODE> y modifica el atributo <CODE>orderStatus</CODE> a
	 * través del método modificador con <CODE>newState</CODE>. Luego
	 * actualiza los datos con el método <CODE>update</CODE>
	 * 
	 * @param orderId
	 *            identificador de la orden de compra a modificar
	 * @param newState
	 *            identificador del nuevo estado de la orden de compra
	 * @return boolean que representa el exito del proceso
	 */
	public boolean changeStatus( int orderId, int newStatus )
	{
		boolean flag = true;
		Order order = new Order(orderId);
		Transaction transaction = new Transaction();

		order.changeState(transaction, newStatus);
		flag = transaction.execute();

		return flag;
	}
}